package jp.gr.java_conf.jo.tgz_plugin;

import java.awt.Component;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.zip.GZIPInputStream;

import org.apache.commons.compress.archivers.tar.TarArchiveEntry;
import org.apache.commons.compress.archivers.tar.TarArchiveInputStream;

import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.ArchiverPlugin;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.FileIOException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.NotImplementedException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.PluginException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.vo.FileInfoVO;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.vo.PluginInfoVO;

public class Main implements ArchiverPlugin {

	public Main() {
		// Ȃ̃RXgN^K{炵
	}

	@Override
	public PluginInfoVO getPluginInfo() {
		PluginInfoVO vo = new PluginInfoVO();
		vo.setAuthor("Jun Ohta");
		vo.setEmail("ohta0065@gmail.com");
		vo.setPluginName("TGZ plugin");
		vo.setVersion("1.0");
		Set<String> set = new HashSet<String>();
		set.add("tgz");
		vo.setSuffixes(set);
		vo.setDetail("tar+gzip `̃A[JCut@Cǂݍނ߂̃vOCB");
		vo.setSupportConfig(false);
		return vo;
	}

	@Override
	public void configurationDlg(Component parent, boolean fullscreen) throws PluginException {
		// 
		throw new NotImplementedException();
	}

	@Override
	public List<FileInfoVO> getArchiveInfo(File file) throws PluginException {
		List<FileInfoVO> retList = new ArrayList<FileInfoVO>();

		try {
			TarArchiveInputStream tin = new TarArchiveInputStream(new GZIPInputStream(new FileInputStream(file)));

			for (TarArchiveEntry tarEnt = tin.getNextTarEntry(); tarEnt != null; tarEnt = tin.getNextTarEntry()) {
				FileInfoVO vo = new FileInfoVO();
				vo.setDirectory(tarEnt.isDirectory());
				vo.setFilename(tarEnt.getName());
				vo.setSize((int) tarEnt.getRealSize());
				vo.setUpdateTime(tarEnt.getModTime());
				retList.add(vo);
			}
			tin.close();
		} catch (IOException e) {
			throw new FileIOException(e);
		}
		return retList;
	}

	@Override
	public InputStream getFile(File archiveFile, String filename) throws PluginException {
		try {
			TarArchiveInputStream tin = new TarArchiveInputStream(
					new GZIPInputStream(new FileInputStream(archiveFile)));
			for (TarArchiveEntry tarEnt = tin.getNextTarEntry(); tarEnt != null; tarEnt = tin.getNextTarEntry()) {
				if (tarEnt.getName().equals(filename)) {
					return tin;
				}
			}
		} catch (IOException e) {
			throw new FileIOException(e);
		}
		return null;
	}
}
