package jp.gr.java_conf.jo.xbm_plugin;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

import javax.imageio.ImageTypeSpecifier;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import jp.gr.java_conf.jo.ZipImageViewer.IBooksFactory;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.ImagePlugin;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.FileIOException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.NotImplementedException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.PluginException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.exception.UnknownFormatException;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.vo.PictureInfoVO;
import jp.gr.java_conf.jo.ZipImageViewer.manager.plugin.vo.PluginInfoVO;
import jp.gr.java_conf.jo.ZipImageViewer.viewer.info.InformationPanel;

/**
 * Xbm `̉摜t@CǂݍރTvvOCB
 * @author jun
 */
public class Main extends JPanel implements ImagePlugin {

	private static final long serialVersionUID = 1L;

	private static JCheckBox box = new JCheckBox("]\");

	public Main() {
		// Ȃ̃RXgN^K{炵
	}

	@Override
	public PluginInfoVO getPluginInfo() {
		PluginInfoVO vo = new PluginInfoVO();
		vo.setAuthor("Jun Ohta");
		vo.setEmail("ohta0065@gmail.com");
		vo.setPluginName("XBM plugin");
		vo.setVersion("1.0");
		Set<String> set = new HashSet<String>();
		set.add("xbm");
		vo.setSuffixes(set);
		vo.setDetail("X bitmap `̉摜ǂݍނ߂̃vOCB");
		vo.setSupportConfig(true);
		return vo;
	}

	@Override
	public void configurationDlg(Component parent, boolean fullscreen) throws PluginException {

		InformationPanel infoPanel = IBooksFactory.getInstance()
				.getViewerFactory().getInformationFactory()
				.getInformationPanel();
		infoPanel.showMessageDialog(parent, box, "config", InformationPanel.INFORMATION_MESSAGE);
	}

	@Override
	public BufferedImage getPicture(InputStream is, PictureInfoVO vo) throws PluginException {
		BufferedImage image;

		Reader reader = new InputStreamReader(is);
		BufferedReader bReader = new BufferedReader(reader);

		try {

			// 
			String line1 = bReader.readLine();
			vo.setWidth(Integer.parseInt(line1.substring(line1.lastIndexOf(" ") + 1)));
			// 
			String line2 = bReader.readLine();
			vo.setHeight(Integer.parseInt(line2.substring(line2.lastIndexOf(" ") + 1)));
			// AXyNg䗦
			vo.setAspectRatio((float) vo.getWidth() / vo.getHeight());
			// tH[}bg
			vo.setFormat("X bitmap");
			// ImageTypeSpecfier
			vo.setType(ImageTypeSpecifier.createFromBufferedImageType(BufferedImage.TYPE_BYTE_BINARY));
			// hInfo
			vo.sethInfo("");

			// 摜{
			image = new BufferedImage(vo.getWidth(), vo.getHeight(), BufferedImage.TYPE_BYTE_BINARY);

			// 3, 4 sڂ #define n܂ꍇ̓XLbv
			String line = bReader.readLine();
			if (line.startsWith("#define")) {
				line = bReader.readLine();
			} else if (!line.startsWith("static")) {
				throw new UnknownFormatException();
			}

			boolean hanten = box.isSelected();

			// '{' ܂ŃXLbv
			while (true) {
				int index = line.lastIndexOf("{");
				if (line.length() == index + 1) {
					line = bReader.readLine();
				}
				if (index >= 0) {
					break;
				}
				line = bReader.readLine();
			}

			int w = 0, h = 0;
			boolean end = false;
			do {
				StringTokenizer token = new StringTokenizer(line, ",");
				while (token.hasMoreTokens()) {
					String target = token.nextToken().trim();

					// '}' I
					int index = target.lastIndexOf("}");
					if (index >= 0) {
						target = target.substring(0, index - 1);
						end = true;
					}

					// 0xff  0x Jbg 10iϊ
					target = target.substring(2);
					int c = Integer.parseInt(target, 16);

					// 1byteł 8sNZ̏Ă
					for (int i = 0; i < 8; i++) {
						// 1byteiԖڂ̃sNZoAimage ɃZbg
						int d = (c >>> i) & 0x01;
						if (hanten) {
							image.setRGB(w++, h, d == 0x00 ? 0xff000000 : 0xffffffff);
						} else {
							image.setRGB(w++, h, d == 0x01 ? 0xff000000 : 0xffffffff);
						}

						// w = width ƂȂc͓ǂݔ΂Ď̍sɈڂ
						if (w == vo.getWidth()) {
							w = 0;
							h++;
							break;
						}
					}
				}
				line = bReader.readLine();
			} while (!end);

		} catch (IOException e) {
			throw new FileIOException(e);
		}
		return image;
	}

	@Override
	public BufferedImage getPreview(InputStream is, Rectangle region, int scalingFactor, PictureInfoVO vo)
			throws PluginException {
		// 
		throw new NotImplementedException();
	}
}
